# File tres/Src/t_trsdecode.x
# By Doug Mink
# May 21, 2008

# TRSDECODE -- Extract apertures, binning, and apertures size from single string

include <error.h>
include <imhdr.h>
include <imio.h>
include <ctype.h>

procedure t_trsdecode ()

char apfib[8]		# Fiber size (s m l) binning (b) ap (1 2 3)

char fibcode[8]		# Returned TRES aperture size (s=1.8, m=2.3, l=2.9)
char fibsize[8]		# Returned TRES aperture size (1.8, 2.3, 2.9)
int binning		# Binning (1 or 2) (returned)
char bincode[8]		# Binning (null or b for 2) (returned)
char apertures[8]	# Returned TRES apertures(s) (1 2 3 12 123)
bool vb			# Log progress (yes or no)

bool clgetb()
int stridx()

begin

	vb = clgetb ("verbose")
	call clgstr ("apfib", apfib, 7)

	if (stridx ('s', apfib) > 0) {
	    call strcpy ("s", fibcode)
	    call strcpy ("1.4", fibsize)
	    }
	else if (stridx ('m', apfib) > 0) {
	    call strcpy ("m", fibcode)
	    call strcpy ("2.3", fibsize)
	    }
	else if (stridx ('l', apfib) > 0) {
	    call strcpy ("l", fibcode)
	    call strcpy ("3.2", fibsize)
	    }
	else {
	    call strcpy ("lms", fibcode)
	    call strcpy ("", fibsize)
	    }

	if (stridx ('b', apfib) > 0) {
	    binning = 2
	    bincode[1] = 'b'
	    bincode[2] = EOS
	    }
	else {
	    binning = 1
	    bincode[1] = EOS
	    }

	apertures[1] = EOS
	if (stridx ('1', apfib) > 0)
	    call strcat ("1", apertures)
	if (stridx ('2', apfib) > 0)
	    call strcat ("2", apertures)
	if (stridx ('3', apfib) > 0)
	    call strcat ("3", apertures)

	if (vb) {
	    call printf ("TRSDECODE %s -> apertures=%s, size=%s(%s), binning=%d(%s)\n")
		call pargstr (apfib)
		call pargstr (apertures)
		call pargstr (fibcode)
		call pargstr (fibsize)
		call pargi (binning)
		call pargstr (bincode)
	    }
	
# Write spectrum parameters to task parameter file
	call clpstr ("apertures", apertures)
	call clputi ("binning", binning)
	call clpstr ("bincode", bincode)
	call clpstr ("fibcode", fibcode)
	call clpstr ("fibsize", fibsize)

end

# May 19 2008	New program
# May 20 2008	Rename from TDECOMP to TRSDECODE
# May 20 2008	Return FIBSIZE in arcseconds as well as FIBCODE
# May 21 2008	Add bincode parameter (b or null)
